import {
    observable,
    action
} from 'mobx';
import * as mobx from 'mobx';
import * as Api from '../apis/sequence'; // 引入API接口文件
import {
    WeaForm
} from 'comsMobx';
import {
    WeaTableNew
} from 'comsMobx';
import {
    Modal,
    message,
} from 'antd'
import {
    i18n
} from '../public/i18n';

const toJS = mobx.toJS;
const {
    TableStore
} = WeaTableNew;

export class SequenceStore {
    @observable tableStore = new TableStore();
    @observable topMenu = []
    @observable rightMenu = [];
    @observable condition = [];
    @observable searchCondition = [];
    @observable isEdit = true;
    @observable isNew = true;
    @observable isPanelShow = false; //高级搜索面板
    @observable form2 = new WeaForm();
    @observable form = new WeaForm();
    @observable form1 = new WeaForm();
    @observable sequenceName = '';
    @observable conditionNum = 2;
    @observable ids = ''; //选择行id
    @observable searchConditionLoading = true;
    @observable nEdialogTitle = '';
    @observable visible = false;
    @observable dialogLoading = true;
    @observable sequenceId = '';
    @observable date = '';
    @observable selectedKey = -1;
    @observable topTab = [];
    @observable topTabCount = {};
    @observable hasRight = '';


    @action
    getTableInfo(isOnChange = false) {
        let params;
        const {current} = this.tableStore;
        if (this.isEmptyObject(this.form2.getFormParams())) {
            params = {
                ...this.form2.getFormParams(),
                sequenceName: this.sequenceName,
                viewcondition:this.selectedKey
            };
        } else {
            params = {
                ...this.form2.getFormParams(),
                viewcondition:this.selectedKey
            };
        }
        Api.getSearchList(params).then(res => {
            if (res.code === 200) {
                this.setHasRight(res.data.hasRight);
                if(res.data.hasRight){
                    isOnChange ? this.tableStore.getDatas(res.data.datas, current) : this.tableStore.getDatas(res.data.datas,1);
                }
            } else {
                message.warning(res.msg);
            }
        }, error => {
            message.warning(error.msg);
        })
        //获取tab信息
        // this.getTabInfo();

    }

    //删除
    delete() {
        let params = {
            ids: this.ids
        };
        Api.deleteTableData(params).then(response => {
            return response.json()
        }).then(data => {
            if (data.code === 200) {
                message.success(i18n.message.deleteSuccess());
                this.getTableInfo();
            } else {
                message.warning(data.msg);
            }
        }).catch(error => {
            message.warning(error.msg);
        })
    }

    save() {
        let params = {
            ...this.form.getFormParams()
        };
        this.form.validateForm().then(f => {
            if (f.isValid) {
                Api.add(params).then(response => {
                    return response.json()
                }).then(data => {
                    if (data.code === 200) {
                        message.success(data.msg);
                        this.getTableInfo();
                        this.setVisible(false);
                    } else {
                        message.warning(data.msg);
                    }
                }).catch(error => {
                    message.warning(error.msg);
                })
            } else {
                f.showErrors();
                this.setDate(new Date());
            }
        });
    }

    edit() {
        let params = { ...this.form.getFormParams(), id: this.sequenceId };
        this.form.validateForm().then(f => {
            if (f.isValid) {
                Api.edit(params).then(response => {
                    return response.json()
                }).then(data => {
                    if (data.code === 200) {
                        message.success(data.msg);
                        this.getTableInfo(true);
                        this.setVisible(false);
                    } else {
                        message.warning(data.msg);
                    }
                }).catch(error => {
                    message.warning(error.msg);
                })
            } else {
                f.showErrors();
                this.setDate(new Date());
            }
        });
    }

    changeData(key) {
        this.setSelectedKey(key);
        this.getTableInfo();
    }

    updateForbiddenTag(checked, id) {
        let params = {
            forbiddenTag: checked,
            id: id
        }
        Api.updateForbiddenTag(params).then(response => {
            return response.json()
        }).then(data => {
            if (data.code === 200) {
                message.success(data.msg);
                this.getTableInfo(true);
            } else {
                message.warning(data.msg);
            }
        }).catch(error => {
            message.warning(error.msg);
        })
    }

    getForm() {
        let params = this.isNew ? {} : {
            id: this.sequenceId
        }
        this.setDialogLoadingStatus(true);
        Api.getSequenceForm(params).then(res => {
            if (res.code === 200) {
                this.setDialogLoadingStatus(false);
                res.data.condition && this.setCondition(res.data.condition);
                res.data.condition && this.form.initFormFields(res.data.condition);
            } else {
                message.warning(res.msg);
            }
        }, error => {
            message.warning(error.msg);
        })

    }

    getSearchCondition() {
        this.setScLoadingStatus(false);
        Api.getAdvanceSearchCondition().then(res => {
            if (res.code === 200) {
                this.setScLoadingStatus(false);
                res.data.conditions && this.setSearchCondition(res.data.conditions);
                res.data.conditions && this.form2.initFormFields(res.data.conditions);
            } else {
                message.warning(res.msg);
            }
        }, error => {
            message.warning(error.msg);
        })
    }

    @action
    getTabInfo() {
        Api.getTabInfo().then(res => {
            if (res.code === 200) {
                res.data.topTabs && this.setTopTab(res.data.topTabs);
                res.data.topTabCount && this.setTopTabCount(res.data.topTabCount);
            } else {
                message.warning(res.msg);
            }
        }, error => {
            message.warning(error.msg);
        })
    }


    @action
    getHasRight() { 
        Api.getHasRight().then(res => {
            if (res.code === 200) {
                res.data.rightMenu && this.setRightMenu(res.data.rightMenu);
                res.data.topMenu && this.setTopMenu(res.data.topMenu);
            } else {
                message.warning(res.msg);
            }
        }, error => {
            message.warning(error.msg);
        })
    }

    updateFields(val) {
        this.form2.updateFields({
            sequenceName: {
                value: val
            }
        });
    }

    setSearchCondition(condition) {
        this.searchCondition = condition;
    }

    setScLoadingStatus(bool) {
        this.searchConditionLoading = bool;
    }

    setPanelStatus(bool) {
        this.isPanelShow = bool;
        bool && this.getSearchCondition();
        if (!bool) {
            this.scLoadingReset();
        }
    }

    setSequenceName(val) {
        this.sequenceName = val;
    }

    isEmptyObject(obj) {
        for (let key in obj) {
            return false;
        }
        return true;
    }

    setIds(ids) {
        this.ids = ids;
    }

    scLoadingReset() {
        this.searchConditionLoading = true;
    }


    formReset() {
        this.form = new WeaForm();
    }

    dialogLoadingReset() {
        this.dialogLoading = true;
    }

    setVisible(bool) {
        this.visible = bool;
        this.formReset();
        !bool && this.dialogLoadingReset();
    }

    setDialogLoadingStatus(bool) {
        this.dialogLoading = bool;
    }

    setNeDialogTitle(title) {
        this.nEdialogTitle = title;
    }

    setIsNew(bool) {
        this.isNew = bool;
    }

    setCondition(condition) {
        this.condition = condition;
    }

    setSequenceId(sequenceId) {
        this.sequenceId = sequenceId;
    }

    setDate(date) {
        this.date = date;
    }

    setSelectedKey(selectedKey) {
        this.selectedKey = selectedKey;
    }

    setTopTab(topTab) {
        this.topTab = topTab;
    }

    setTopTabCount(topTabCount) {
        this.topTabCount = topTabCount;
    }

    setTopMenu(topMenu) {
        this.topMenu = topMenu;
    }

    setRightMenu(rightMenu) {
        this.rightMenu = rightMenu;
    }

    setHasRight(bool) {
        this.hasRight = bool;
    }

}